// NeoPixel Ring simple sketch (c) 2013 Shae Erisson
// released under the GPLv3 license to match the rest of the AdaFruit NeoPixel library

#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h>
#endif

// Which pin on the Arduino is connected to the NeoPixels?
// On a Trinket or Gemma we suggest changing this to 1
#define PIN            8

// How many NeoPixels are attached to the Arduino?
#define NUMPIXELS      1

// When we setup the NeoPixel library, we tell it how many pixels, and which pin to use to send signals.
// Note that for older NeoPixel strips you might need to change the third parameter--see the strandtest
// example for more information on possible values.
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

int delayval = 50; // delay between color changes
float RGB1[3];
float RGB2[3];
float INC[3];
float SUM;
uint8_t red, green, blue;

void setup() {
  //--- Kiindulási színek generálása, véletlenszerűen  
  for (int x=0; x<3; x++) {
    RGB1[x] = random(256);
    RGB2[x] = random(256); 
  } 
  pixels.begin(); // This initializes the NeoPixel library.
}

void loop() {
  //--- Az 1. színből a 2. színbe történő átmenet lépéseinek meghatározása  
  for (int x=0; x<3; x++) {
    INC[x] = (RGB1[x] - RGB2[x]) / 50; 
  } 

  for (int s=0; s<256; s+=5) {
    red = int(RGB1[0]);
    green = int(RGB1[1]);
    blue = int(RGB1[2]);

    //--- A közelítő szín kijelzése
    pixels.setPixelColor(0, pixels.Color(red,green,blue)); // 
    pixels.show(); // This sends the updated pixel color to the hardware.
    for (int x=0; x<3; x++) {
      RGB1[x] -= INC[x];   //Közelítünk a másik színhez    
    }
    delay(delayval);
  }
  Serial.println("---------------");
//--- Új színt konstruálunk, véletlen számok generálásával 
    for (int x=0; x<3; x++) {
      RGB2[x] = random(256);
    }
}

